POJ - 3126(BFS)

题目链接:http://poj.org/problem?id=3126

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

    给出两个四位数的素数a,b,求从a变到b最少要花几步?每一步只能将a中的一位改变,且改变后的数也要是素数。

扫描二维码关注公众号,回复: 2206140 查看本文章

思路:

    枚举搜索,我不知道怎么得到的,但我可以一直搜~。千位,百位,十位,个位的数依次替换,依次深入搜索。

注意:

    以前总喜欢把标记路径的Vir放在出队时,其实应该放在入队的时候,这样就不会有一样的数据入队,节省了不少时间和空间。

AC代码:    

Time 63ms
Memory 608kB
Length 1363

#include <cstdio>
#include <cmath>
#include <queue>
#include <cstring>
using namespace std;
struct Q
{
    int x[4];
    int s;
}no,de;
queue<Q> iq;
int n,a,b,ans,t[4];
int vir[10008];

bool isPrime( int x )
{
    for( int i=2; i<=sqrt(x); i++ )
    if( x%i == 0 )
    return false;
    return true;
}

int wirte( int* a)
{
    return a[0]*1000+a[1]*100+a[2]*10+a[3];
}
void bfs( )
{
    while( !iq.empty() )
    iq.pop();
    ans=0;
    memset(vir,0,sizeof(vir));

    no.s=0;
    for( int i=0; i<4; i++ )
    {
        no.x[3-i]=a%10;
        a/=10;
    }
    iq.push(no);
    vir[wirte(no.x)] = 1 ;

    while( !iq.empty() )
    {
        no = iq.front();
        iq.pop();


        if( wirte(no.x)==b )
        {
            printf("%d\n",no.s);
            return ;
        }

        for( int i=0; i<4; i++ )
        {
            de=no;
            for( int j=0; j<=9; j++ )
            {
                if( i==0 && j==0 ) continue;
                de.x[i] = j ;
                if( !vir[wirte(de.x)] && isPrime(wirte(de.x)))
                {
                    vir[wirte(de.x)] = 1 ;
                    de.s=no.s+1;
                    iq.push(de);
                }
            }
        }
    }
    printf("Impossible\n");
}

int main()
{
    scanf("%d",&n);
    while( n-- )
    {
        scanf("%d%d",&a,&b);
        bfs();
    }
    return 0;
}
和其他代码比,优点在于可修改性强一点吧~(自我安慰.jpg)


猜你喜欢

转载自blog.csdn.net/qq_40764917/article/details/80957674